/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_SETO                                                     */
/* Tabela : SETORCOZ                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_SETO'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_SETO
GO

CREATE TRIGGER DTULTATU_SETO
ON SETORCOZ
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'SETORCOZ', CDFILIAL, 'CDFILIAL='  + CDFILIAL  + ';'+
                                             'CDSETORCOZ='+ CDSETORCOZ+ ';', GETDATE() FROM DELETED)
   END
   ELSE BEGIN
      UPDATE SETORCOZ
      SET DTULTATUSETC = GETDATE()
      FROM INSERTED
      WHERE (ISNULL(SETORCOZ.CDSETORCOZ,0) = ISNULL(INSERTED.CDSETORCOZ,0)) AND
            (ISNULL(SETORCOZ.NMSETORCOZ,0) = ISNULL(INSERTED.NMSETORCOZ,0));    
   END;
END;
GO

